=== regress/unittests/Makefile ===
#	$OpenBSD: Makefile,v 1.13 2023/09/24 08:14:13 claudio Exp $

SUBDIR=	test_helper sshbuf sshkey bitmap kex hostkeys utf8 match conversion
SUBDIR+=authopt misc sshsig

.include <bsd.subdir.mk>
