=== debian/changelog ===
openssh (1:10.2p1-5) unstable; urgency=medium

  [ Samuel Thibault ]
  * Do not link against libcrypt on GNU/Hurd (closes: #1128399).

  [ Colin Watson ]
  * Install systemd files directly to /usr and drop dh-sequence-movetousr
    (closes: #1122765).

 -- Colin Watson <cjwatson@debian.org>  Thu, 19 Feb 2026 10:46:15 +0000

openssh (1:10.2p1-4) unstable; urgency=medium

  [ Colin Watson ]
  * Debconf translations:
    - Simplified and Traditional Chinese (thanks, Yangfl; closes: #1124970).

  [ Luca Boccassi ]
  * openssh-client: use sysusers.d instead of manual scripting.
  * openssh-client: drop compat postinst not needed since bookworm/noble.
  * openssh-client: drop versioned dependency on i-s-h, satisfied since
    trixie/noble.
  * openssh-client: drop dependency on passwd, add recommends on
    openssh-server.
  * Use dh-sequence-installsysusers and drop d/rules override.

  [ Christian Göttsche ]
  * Reorder pam_selinux(7) usage (closes: #747303).

 -- Colin Watson <cjwatson@debian.org>  Wed, 18 Feb 2026 14:09:13 +0000

openssh (1:10.2p1-3) unstable; urgency=medium

  * Drop "Rules-Requires-Root: no", default as of dpkg-dev 1.22.13.
  * Drop openssh-server's dependency on lsb-base.
  * Remove support for direct upgrades from before Debian 12 (bookworm).
  * Rewrite scp-quoting.patch using argv_assemble, and forward it upstream.

 -- Colin Watson <cjwatson@debian.org>  Tue, 02 Dec 2025 14:36:37 +0000

openssh (1:10.2p1-2) unstable; urgency=medium

  * ssh-session-cleanup: Update pattern for sshd-session split in 9.8
    (closes: #1117965).
  * Link ssh against ssh-pkcs11.o directly (closes: #1117638, #1117720).

 -- Colin Watson <cjwatson@debian.org>  Fri, 17 Oct 2025 10:14:14 +0100

openssh (1:10.2p1-1) unstable; urgency=medium

  * New upstream release:
    - ssh-keygen(1): fix download of keys from PKCS#11 tokens.

 -- Colin Watson <cjwatson@debian.org>  Fri, 10 Oct 2025 14:50:27 +0100
