=== debian/tests/control ===
Tests:
 regress,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-sudo,
Depends:
 devscripts,
 dropbear,
 haveged,
 openssh-tests,
 openssl,
 passwd,
 putty-tools,
 python3-twisted,
 sudo,
 sysvinit-utils,

Tests:
 ssh-gssapi,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-root,
Depends:
 adduser,
 krb5-admin-server,
 krb5-kdc,
 openssh-server-gssapi,

Tests:
 socket-activation,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-sudo,
Depends:
 openssh-server,
 passwd,

Tests:
 xinetd,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-sudo,
Depends:
 openssh-server,
 passwd,
 xinetd,
